package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HRArchives;
import cn.ibizlab.humanresource.core.humanresource.filter.HRArchivesSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRArchives] 服务对象接口
 */
public interface IHRArchivesService extends IService<HRArchives>{

    boolean create(HRArchives et) ;
    void createBatch(List<HRArchives> list) ;
    boolean update(HRArchives et) ;
    void updateBatch(List<HRArchives> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRArchives get(String key) ;
    HRArchives getDraft(HRArchives et) ;
    boolean checkKey(HRArchives et) ;
    boolean save(HRArchives et) ;
    void saveBatch(List<HRArchives> list) ;
    Page<HRArchives> searchActive(HRArchivesSearchContext context) ;
    Page<HRArchives> searchDefault(HRArchivesSearchContext context) ;
    Page<HRArchives> searchNonArchives(HRArchivesSearchContext context) ;
    Page<HRArchives> searchNonEmployee(HRArchivesSearchContext context) ;
    List<HRArchives> selectByHremployeeid(String employeeid) ;
    void removeByHremployeeid(String employeeid) ;
    List<HRArchives> selectByHrorganizationid(String organizationid) ;
    void removeByHrorganizationid(String organizationid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRArchives> getHrarchivesByIds(List<String> ids) ;
    List<HRArchives> getHrarchivesByEntities(List<HRArchives> entities) ;
}


